<%@ WebService Language="VB" Class="AutoComplete" %>

Imports System.Collections.Generic
Imports System.Data
Imports System.Data.Common
Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Web.Script.Services

<WebService(Namespace:="http://tempuri.org/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<ScriptService()> _
Public Class AutoComplete
    Inherits System.Web.Services.WebService
    
    <WebMethod()> _
    Public Function GetCompletionList(ByVal prefixText As String, ByVal count As Integer) As String()
        Dim list As New List(Of String)
        Dim setting As ConnectionStringSettings = _
          ConfigurationManager.ConnectionStrings("MyDB")
        Dim factory As DbProviderFactory = _
          DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            Dim comm As DbCommand = factory.CreateCommand()
            comm.Connection = db
            comm.CommandText = String.Format("SELECT TOP {0} keywd FROM Keyword WHERE keywd LIKE @keywd", count)
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@keywd"
            param.Value = Me.EscapeSql(prefixText) & "%"
            comm.Parameters.Add(param)
            db.Open()
            Dim reader As DbDataReader = comm.ExecuteReader()
            Do While reader.Read()
                list.Add(reader("keywd"))
            Loop
        End Using
        Return list.ToArray()
    End Function
    
    Private Function EscapeSql(ByVal val As String) As String
        Dim escape As String() = {"[", "%", "_"}
        For i As Integer = 0 To escape.Length - 1
            val = val.Replace(escape(i), String.Format("[{0}]", escape(i)))
        Next
        Return val
    End Function
    
End Class
