<%@ WebService Language="VB" Class="CascadingDropDownList" %>

Imports AjaxControlToolkit
Imports System.Collections.Generic
Imports System.Data
Imports System.Data.Common
Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Web.Script.Services

<WebService(Namespace:="http://tempuri.org/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<ScriptService()> _
Public Class CascadingDropDownList
    Inherits System.Web.Services.WebService
    
    <WebMethod()> _
    Public Function GetDropDownData(ByVal knownCategoryValues As String, ByVal category As String) As CascadingDropDownNameValue()
        Dim list As New List(Of CascadingDropDownNameValue)
        Dim setting As ConnectionStringSettings = _
          ConfigurationManager.ConnectionStrings("MyDB")
        Dim factory As DbProviderFactory = _
          DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            Dim comm As DbCommand = factory.CreateCommand()
            comm.Connection = db
            Select Case category
                Case "Category"
                    comm.CommandText = "SELECT DISTINCT category ,category AS c FROM Book ORDER BY category"
                Case "Title"
                    comm.CommandText = "SELECT isbn ,title FROM Book WHERE category=@category"
                    Dim param As DbParameter = factory.CreateParameter()
                    param.ParameterName = "@category"
                    Dim dic As StringDictionary = CascadingDropDown.ParseKnownCategoryValuesString(knownCategoryValues)
                    param.Value = dic.Item("Category")
                    comm.Parameters.Add(param)
            End Select
            db.Open()
            Dim reader As DbDataReader = comm.ExecuteReader()
            Do While reader.Read()
                Dim cv As New CascadingDropDownNameValue(reader(1), reader(0))
                list.Add(cv)
            Loop
        End Using
        Return list.ToArray()
    End Function
End Class
