<%@ WebService Language="VB" Class="Slideshow" %>

Imports AjaxControlToolkit
Imports System.IO
Imports System.Collections.Generic
Imports System.Data
Imports System.Data.Common
Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Web.Script.Services

<WebService(Namespace:="http://tempuri.org/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<ScriptService()> _
Public Class Slideshow
    Inherits System.Web.Services.WebService
    
    <WebMethod()> _
    Public Function GetSlides(ByVal contextKey As String) As Slide()
        Dim slides As New List(Of Slide)
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("MyDB")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            Dim comm As DbCommand = factory.CreateCommand()
            comm.Connection = db
            comm.CommandText = "SELECT title, path, descript FROM Slide WHERE category=@category ORDER BY id"
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@category"
            param.Value = contextKey
            comm.Parameters.Add(param)
            db.Open()
            Dim reader As DbDataReader = comm.ExecuteReader()
            Do While reader.Read()
                Dim tslide As New Slide( _
                    reader("path"), reader("title"), reader("descript"))
                slides.Add(tslide)
            Loop
        End Using
        Return slides.ToArray()
    End Function
End Class
