Type.registerNamespace('MyAjax');

MyAjax.DynamicProxyBehavior = function(element) {

    MyAjax.DynamicProxyBehavior.initializeBase(this, [element]);

    this._PopulateTriggerControlIDValue = null;
    this._ContextControlIDValue = null;
    this._ServicePathValue = null;
    this._ServiceMethodValue = null;
}

MyAjax.DynamicProxyBehavior.prototype = {

    initialize : function() {
        MyAjax.DynamicProxyBehavior.callBaseMethod(this, 'initialize');

        $addHandler(
            $get(this._PopulateTriggerControlIDValue),
            "click",
            Function.createDelegate(this, this._onClick)
        );
    },

    dispose : function() {
        MyAjax.DynamicProxyBehavior.callBaseMethod(this, 'dispose');
    },

    _onClick : function(e) {
        Sys.Net.WebServiceProxy.invoke(
            this._ServicePathValue,
            this._ServiceMethodValue,
            false,
            {key: $get(this._ContextControlIDValue).value},
            Function.createDelegate(this, this._onSuccess)
        );
        return false;
    },
    
    _onSuccess : function(result,context,method) {
        this.get_element().innerHTML = result;
    },
    
    get_PopulateTriggerControlID : function() {
        return this._PopulateTriggerControlIDValue;
    },

    set_PopulateTriggerControlID : function(value) {
        if (this._PopulateTriggerControlIDValue != value) {
            this._PopulateTriggerControlIDValue = value;
            this.raisePropertyChanged('PopulateTriggerControlID');
        }
    },
    
    get_ContextControlID : function() {
        return this._ContextControlIDValue;
    },

    set_ContextControlID : function(value) {
        if (this._ContextControlIDValue != value) {
            this._ContextControlIDValue = value;
            this.raisePropertyChanged('ContextControlID');
        }
    },
    
    get_ServicePath : function() {
        return this._ServicePathValue;
    },

    set_ServicePath : function(value) {
        if (this._ServicePathValue != value) {
            this._ServicePathValue = value;
            this.raisePropertyChanged('ServicePath');
        }
    },
    
    get_ServiceMethod : function() {
        return this._ServiceMethodValue;
    },

    set_ServiceMethod : function(value) {
        if (this._ServiceMethodValue != value) {
            this._ServiceMethodValue = value;
            this.raisePropertyChanged('ServiceMethod');
        }
    }
}

MyAjax.DynamicProxyBehavior.registerClass('MyAjax.DynamicProxyBehavior', AjaxControlToolkit.BehaviorBase);
