﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.Common" %>
<%@ Import Namespace="System.Web.Services" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    [WebMethod()]
    public static String GetBookByIsbn(String isbn){
        String result = null;
        ConnectionStringSettings setting =
            ConfigurationManager.ConnectionStrings["MyDB"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db = factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            DbCommand comm = factory.CreateCommand();
            comm.CommandText =
                "SELECT title FROM Book WHERE isbn=@isbn";
            comm.Connection = db;
            DbParameter param = factory.CreateParameter();
            param.ParameterName = "@isbn";
            param.Value = isbn;
            comm.Parameters.Add(param);
            db.Open();
            DbDataReader reader = comm.ExecuteReader();
            if(reader.Read()){
                result = (String)reader["title"];
            } else {
                throw new Exception("書籍情報が存在しません。");
            }
        }
        return result;
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>サービスブリッジ</title>
    <script type="text/javascript">
    function BookSearch(){
        ServiceBridge.GetBookByIsbn(
            $get('txtIsbn').value,
            function(result,context,method) {
                $get('result').innerHTML = result;
            },
            function(ex,context,method) {
                $get('result').innerHTML = ex.get_message();
            }
        );
        return false;
    }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="manager" runat="server" EnablePageMethods="True">
            <Services>
                <asp:ServiceReference Path="ServiceBridge.asmx" />
            </Services>
        </asp:ScriptManager>
        ISBNコード：<asp:TextBox ID="txtIsbn" runat="server"></asp:TextBox>&nbsp;<asp:Button
            ID="btnSave" runat="server" OnClientClick="return BookSearch()" Text="検索" /><br />
        <div id="result">
        </div>
    
    </div>
    </form>
</body>
</html>
