<%@ WebService Language="C#" Class="Scripts" %>

using System;
using System.Configuration;
using System.Data;
using System.Data.Common;
using System.Web;
using System.Web.Script.Services;
using System.Web.Services;
using System.Web.Services.Protocols;

[WebService(Namespace="http://tempuri.org/")]
[WebServiceBinding(ConformsTo=WsiProfiles.BasicProfile1_1)]
[ScriptService()]
public class Scripts : System.Web.Services.WebService {
    
    [WebMethod()]
    public MapInfo GetMapInfo(String mid) {
        MapInfo inf = new MapInfo();
        ConnectionStringSettings setting =
            ConfigurationManager.ConnectionStrings["MyDB"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db = factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            DbCommand comm = factory.CreateCommand();
            comm.CommandText =
                "SELECT subject, url, axisX, axisY, descript FROM Mapinfo WHERE mid=@mid";
            comm.Connection = db;
            DbParameter param = factory.CreateParameter();
            param.ParameterName = "@mid";
            param.Value = mid;
            comm.Parameters.Add(param);
            db.Open();
            DbDataReader reader = comm.ExecuteReader();
            if(reader.Read()){
                inf.Subject = (String)reader["subject"];
                inf.Url = (String)reader["Url"];
                inf.AxisX = reader["AxisX"].ToString();
                inf.AxisY = reader["AxisY"].ToString();
                inf.Descript = (String)reader["Descript"];
            }
        }
        return inf;
    }
}

public class MapInfo {
    public String Subject;
    public String Url;
    public String AxisX;
    public String AxisY;
    public String Descript;
}
