<%@ WebService Language="C#" Class="AutoComplete" %>

using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.Common;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.Script.Services;

[WebService(Namespace="http://tempuri.org/")]
[WebServiceBinding(ConformsTo=WsiProfiles.BasicProfile1_1)]
[ScriptService()]
public class AutoComplete : System.Web.Services.WebService {
    
    [WebMethod()]
    public String[] GetCompletionList(String prefixText, Int32 count) {
        List<String> list = new List<String>();
        ConnectionStringSettings setting =
          ConfigurationManager.ConnectionStrings["MyDB"];
        DbProviderFactory factory =
          DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db = factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            DbCommand comm = factory.CreateCommand();
            comm.Connection = db;
            comm.CommandText = String.Format("SELECT TOP {0} keywd FROM Keyword WHERE keywd LIKE @keywd", count);
            DbParameter param = factory.CreateParameter();
            param.ParameterName = "@keywd";
            param.Value = this.EscapeSql(prefixText) + "%";
            comm.Parameters.Add(param);
            db.Open();
            DbDataReader reader = comm.ExecuteReader();
            while(reader.Read()){
                list.Add((String)reader["keywd"]);
            }
        }
        return list.ToArray();
    }
    
    private String EscapeSql(String val) {
        String[] escape = {"[", "%", "_"};
        for(Int32 i=0;i<escape.Length;i++){
            val = val.Replace(escape[i], String.Format("[{0}]", escape[i]));
        }
        return val;
    }    
}
