<%@ WebService Language="C#" Class="CascadingDropDownList" %>

using AjaxControlToolkit;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Data;
using System.Data.Common;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.Script.Services;

[WebService(Namespace="http://tempuri.org/")]
[WebServiceBinding(ConformsTo=WsiProfiles.BasicProfile1_1)]
[ScriptService()]
public class CascadingDropDownList : System.Web.Services.WebService {
    
    [WebMethod()]
    public CascadingDropDownNameValue[] GetDropDownData(String knownCategoryValues, String category) {
        List<CascadingDropDownNameValue> list = new List<CascadingDropDownNameValue>();
        ConnectionStringSettings setting =
          ConfigurationManager.ConnectionStrings["MyDB"];
        DbProviderFactory factory =
          DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db = factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            DbCommand comm = factory.CreateCommand();
            comm.Connection = db;
            switch(category){
                case "Category" :
                    comm.CommandText = "SELECT DISTINCT category ,category AS c FROM Book ORDER BY category";
                    break;
                case "Title" :
                    comm.CommandText = "SELECT isbn ,title FROM Book WHERE category=@category";
                    DbParameter param = factory.CreateParameter();
                    param.ParameterName = "@category";
                    StringDictionary dic = CascadingDropDown.ParseKnownCategoryValuesString(knownCategoryValues);
                    param.Value = dic["Category"];
                    comm.Parameters.Add(param);
                    break;
            }
            db.Open();
            DbDataReader reader = comm.ExecuteReader();
            while(reader.Read()){
                CascadingDropDownNameValue cv = new CascadingDropDownNameValue((String)reader[1], (String)reader[0]);
                list.Add(cv);
            }
        }
        return list.ToArray();
    }
}
