<%@ WebService Language="C#" Class="Slideshow" %>

using AjaxControlToolkit;
using System;
using System.Configuration;
using System.IO;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Web.Script.Services;

[WebService(Namespace="http://tempuri.org/")]
[WebServiceBinding(ConformsTo=WsiProfiles.BasicProfile1_1)]
[ScriptService()]
public class Slideshow : System.Web.Services.WebService {
    
    [WebMethod()]
    public Slide[] GetSlides(String contextKey){
        List<Slide> slides = new List<Slide>();
        ConnectionStringSettings setting =
            ConfigurationManager.ConnectionStrings["MyDB"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db = factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            DbCommand comm = factory.CreateCommand();
            comm.Connection = db;
            comm.CommandText = "SELECT title, path, descript FROM Slide WHERE category=@category ORDER BY id";
            DbParameter param = factory.CreateParameter();
            param.ParameterName = "@category";
            param.Value = contextKey;
            comm.Parameters.Add(param);
            db.Open();
            DbDataReader reader = comm.ExecuteReader();
            while(reader.Read()){
                Slide tslide = new Slide(
                    (String)reader["path"], (String)reader["title"],
                    (String)reader["descript"]);
                slides.Add(tslide);
            }
        }
        return slides.ToArray();
    }
}