﻿Type.registerNamespace('MyAjax');

MyAjax.HoverPopupBehavior = function(element) {

  MyAjax.HoverPopupBehavior.initializeBase(this, [element]);

  this._popupElement = null;
  this._popupBehavior = null;
 
  this._DisplayImageValue = null;
}

MyAjax.HoverPopupBehavior.prototype = {

  initialize : function() {
    MyAjax.HoverPopupBehavior.callBaseMethod(this, 'initialize');

	// ターゲット上でmouseoverイベントが発生した場合の処理
    $addHandler(
      this.get_element(),
      "mouseover",
      Function.createDelegate(this, this._onMouseOver)
    );
	// ターゲット上でmouseoutイベントが発生した場合の処理
    $addHandler(
      this.get_element(),
      "mouseout",
      Function.createDelegate(this, this._onMouseOut)
    );
  },

  dispose : function() {
    MyAjax.HoverPopupBehavior.callBaseMethod(this, 'dispose');
  },

	// mouseoverイベントに対応するハンドラ関数
  _onMouseOver : function() {
    var elem = this.get_element();
	// DisplayImageプロパティ無指定の場合、アセンブリ内のデフォルト画像を取得
    var img = (this._DisplayImageValue==null) ? "<%=WebResource("MyAjax.HoverPopupDefault.jpg") %>" : this._DisplayImageValue;
	// ポップアップ用の画像（<img>）要素を生成
    this._popupElement =
      CommonToolkitScripts.createElementFromTemplate(
      { 
        nodeName : "img",
        properties : {
          src : img,
          alt : ""
        }
      },
      elem.parentNode);

	// ポップアップ機能を持つAjaxControlToolkit.PopupBehaviorオブジェクトを生成
    this._popupBehavior = $create(
      AjaxControlToolkit.PopupBehavior,
      {
        parentElement : this.get_element(), 
        positioningMode : AjaxControlToolkit.PositioningMode.BottomLeft
      }, 
      null,
      null,
      this._popupElement);
	// ポップアップ表示を実行
    this._popupBehavior.show();
  },

	// mouseoverイベントに対応するハンドラ関数（ポップアップ画像を非表示）
  _onMouseOut : function(e) {
    this._popupBehavior.hide();
  },

	// DisplayImageプロパティを定義
  get_DisplayImage : function() {
    return this._DisplayImageValue;
  },

  set_DisplayImage : function(value) {
    if (this._DisplayImageValue != value) {
      this._DisplayImageValue = value;
      this.raisePropertyChanged('DisplayImage');
    }
  }
}

MyAjax.HoverPopupBehavior.registerClass('MyAjax.HoverPopupBehavior', AjaxControlToolkit.BehaviorBase);
